/*
   Client pour invoquer le web service skybot 
   Info: http://skybot.imcce.fr
*/

#include <string.h>
#include <stdio.h>
#include <getopt.h>

#include "soapH.h"
#include "SkyBoTBinding.nsmap"

int main(int argc, char *argv[])
{ 
   /* declaration des variables */
   const char *wsname = "http://www.imcce.fr/webservices/skybot/skybot.php";
   struct soap soap;
   struct ns1__skybotRequest input;
   char *result, *substr;
   const char *lex = ";";

   char *s_options = "hj:c:r:m:o:g:";
   static struct option long_options[] = {
      {"help",     no_argument,       0, 'h'},
      {"jd",       required_argument, 0, 'j'},
      {"center",   required_argument, 0, 'c'},
      {"radius",   required_argument, 0, 'r'},
      {"mime",     required_argument, 0, 'm'},
      {"output",   required_argument, 0, 'o'},
      {"observer", required_argument, 0, 'g'}
   };
   int c, option_index = 0;
   char *s_jd = NULL;
   char *s_coord = NULL;

   /* initialisations par defaut */
   input.radius = malloc(strlen("900x900") + 1);
   strcpy(input.radius, "900x900");
   input.mime = malloc(strlen("text") + 1);
   strcpy(input.mime, "text");
   input.output = malloc(strlen("basic") + 1);
   strcpy(input.output, "basic");
   input.observer = malloc(strlen("500") + 1);
   strcpy(input.observer, "500");

   /* lecture des arguments */
   while((c = getopt_long(argc, argv, s_options, long_options, &option_index)) != -1)
   {
      switch (c)
      {
      case 'h':
         usage_help(argv[0], 0);
         exit(EXIT_SUCCESS);
      case 'j':
         s_jd = optarg;
         break;
      case 'c':
         s_coord = optarg;
         break;
      case 'r':
         input.radius = malloc(strlen(optarg) + 1);
         strcpy(input.radius, optarg);
         break;
      case 'm':
         input.mime = malloc(strlen(optarg) + 1);
         strcpy(input.mime, optarg);
         break;
      case 'o':
         input.output = malloc(strlen(optarg) + 1);
         strcpy(input.output, optarg);
         break;
      case 'g':
         input.observer = malloc(strlen(optarg) + 1);
         strcpy(input.observer, optarg);
         break;
      default:
         usage_help(argv[0], 0);
         exit(EXIT_SUCCESS);
      }
   }

   if(s_jd != NULL)
   {
      input.epoch = atof(s_jd);
   }
   else
   {
      usage_help(argv[0], 0);
      exit(EXIT_SUCCESS);
   }

   if(s_coord != NULL)
   {
      input.alpha = atof(s_coord);
   }
   else
   {
      usage_help(argv[0], 0);
      exit(EXIT_SUCCESS);
   }

   /* Invocation du web service */
   soap_init(&soap);
   soap_call_ns1__skybot(&soap, wsname, NULL, &input, &result);

   if (soap.error)
   {
      /* Print SOAP error */
      soap_print_fault(&soap, stderr);
   }
   else
   {
      /* Print result */
      substr = strtok(result, lex);
      while( substr != NULL )
      {
         printf("%s\n", substr);
         substr = strtok(NULL, lex);
      }
   }

   soap_end(&soap);
   soap_done(&soap);
   return EXIT_SUCCESS;
}
