/*
   Client pour invoquer le web service skybotstatus 
   Info: http://vo.imcce.fr/webservices/skybot
*/

#include <string.h>
#include <stdio.h>
#include <getopt.h>

#include "soapH.h"
#include "SkyBoTBinding.nsmap"

int main(int argc, char *argv[])
{
   /* declaration des variables */
   const char *wsname = "http://www.imcce.fr/webservices/skybot/skybot.php";
   struct soap soap;
   char mime[8];
   char *result;
   char *substr;
   const char *lex = ";";

   char *s_options = "hm:";
   static struct option long_options[] = {
      {"help",     no_argument,       0, 'h'},
      {"mime",     required_argument, 0, 'm'}
   };
   int c, option_index = 0;

   /* initialisations par defaut */
   strcpy(mime, "text");

   /* lecture des arguments */
   while((c = getopt_long(argc, argv, s_options, long_options, &option_index)) != -1)
   {
      switch (c)
      {
      case 'h':
         usage_help(argv[0], 2);
         exit(EXIT_SUCCESS);
      case 'm':
         strcpy(mime, optarg);
         break;
      default:
         usage_help(argv[0], 2);
         exit(EXIT_SUCCESS);
      }
   }

   /* Invocation du web service */
   soap_init(&soap);
   soap_call_ns1__skybotstatus(&soap, wsname, NULL, mime, &result);

   if (soap.error)
   {
      /* Print SOAP error */
      soap_print_fault(&soap, stderr);
   }
   else
   {
      /* Print result */
      substr = strtok(result, lex);
      while( substr != NULL )
      {
         printf("%s\n", substr);
         substr = strtok(NULL, lex);
      }
   }

   soap_end(&soap);
   soap_done(&soap);
   return EXIT_SUCCESS;
}

