#include <stdio.h>

void usage_help(char *prgme, int topic)
{
  FILE *p_f = stdout;

  fprintf(p_f, "-------------------------------------------------------------------------------------\n");
  switch (topic)
  {
    case 0:
      fprintf(p_f, "- SkyBoT client -\n");
      break;
    case 1:
      fprintf(p_f, "- SkyBoTResolver client -\n");
      break;
    case 2:
      fprintf(p_f, "- SkyBoTStatus client -\n");
      break;
    default:
      fprintf(p_f, "- Unknown SkyBoT client -\n");
  }
  fprintf(p_f, "-------------------------------------------------------------------------------------\n");
  fprintf(p_f, "Usage: %s [args] [options]\n",prgme);

  switch (topic)
  {
    case 0:
      fprintf(p_f, "Args:\n");
      fprintf(p_f, "   -j <value>, --jd <value>        Julian day (UTC) of the requested epoch\n");
      fprintf(p_f, "   -c <value>, --center <value>    J2000 equatorial geocentric coordinates of the\n");
      fprintf(p_f, "                                   FOV center, in degrees (e.g. 15.1234+20.04432)\n");
      fprintf(p_f, "Options:\n");
      fprintf(p_f, "   -r <value>, --radius <value>    Radius of the field of view, in arcsec (e.g. 900x900 or 1200)\n");
      fprintf(p_f, "   -m <value>, --mime <value>      Mime type of the result: (text)|html|votable\n");
      fprintf(p_f, "   -o <value>, --output <value>    Kind of results: object|(basic)|all\n");
      fprintf(p_f, "   -g <value>, --observer <value>  IAU code of the observer location (e.g 007 or I03)\n");
      break;

    case 1:
      fprintf(p_f, "Args:\n");
      fprintf(p_f, "   -i <value>, --iso <value>       Gregorian date (UTC) of the requested epoch expressed in ISO format\n");
      fprintf(p_f, "   -j <value>, --jd <value>        Julian day (UTC) of the requested epoch\n");
      fprintf(p_f, "   -n <value>, --name <value>      Name or designation of the target\n");
      fprintf(p_f, "Options:\n");
      fprintf(p_f, "   -m <value>, --mime <value>      Mime type of the result: (text)|html|votable\n");
      fprintf(p_f, "   -o <value>, --output <value>    Kind of results: object|(basic)|all\n");
      fprintf(p_f, "   -g <value>, --observer <value>  IAU code of the observer location (e.g 007 or I03)\n");
      break;

    case 2:
      fprintf(p_f, "Options:\n");
      fprintf(p_f, "   -m <value>, --mime <value>      Mime type of the result: (text)|html|votable\n");
      break;

    default:
      fprintf(p_f, "what?\n");
  }
  fprintf(p_f, "\n");
  fprintf(p_f, "(C) 2006, IMCCE - J. Berthier & J. Normand\n");
}
